#ifndef __BIRTHDEATH_H__
#define __BIRTHDEATH_H__

#include<mathfunc.h>
#include<memalloc.h>
#include<utils.h>

extern double birthdeath_rate(int c, int s,  int branchlength, double lambda  );

typedef struct
{
	int branchlength;
	double lambda;
	int maxFamilysize;
}BirthDeathCacheAttrib;

typedef BirthDeathCacheAttrib* pBirthDeathCacheAttrib;

typedef struct
{
	pArrayList list;
	int maxFamilysize;
	int base_bl;
}BirthDeathCacheArray;
typedef BirthDeathCacheArray* pBirthDeathCacheArray;

typedef struct 
{
	BirthDeathCacheAttrib attrib;
	double** matrix;	
}BirthDeathCache;
typedef BirthDeathCache* pBirthDeathCache;

extern int maxFamilysize;

extern void birthdeath_cache_array_free(pBirthDeathCacheArray pbdc_array);
extern pBirthDeathCache birthdeath_cache_new( int branchlength, double lambda, int maxFamilysize );
double** birthdeath_cache_get_matrix(pBirthDeathCacheArray pbdc_array, int branchlength, double lambda );
extern double birthdeath_cache_get(pBirthDeathCacheArray pbdc_array, int s, int c, int branchlength, double lambda );
extern void thread_run(int numthreads, void* (*run)(void*), void* param, int size );
extern pBirthDeathCacheArray birthdeath_cache_array_new_with_list_thread(int* bl, int size, 
		int maxFamilysize, double lambda, int numthreads );

extern int chooseln_is_init();
extern void chooseln_cache_init();
extern void chooseln_cache_resize(int resize);
extern void chooseln_cache_free();
#endif
