#ifndef __MEMALLOC_H__
#define __MEMALLOC_H__

#include<string.h>
#include<errno.h>
#include<stdarg.h>
#include<stdlib.h>
#include<stdio.h>

#define MEMORY_NEW(a,b) 			(b*)memory_new(a,sizeof(b))
#define MEMORY_NEW_2DIM(r,c,s)	 	(s**)memory_new_2dim(r,c,sizeof(s))
#define MEMORY_NEW_WITH_CLEAR(a,b) 	(b*)memory_new_with_clear(a,sizeof(b))
#define MEMORY_NEW_2DIM_WITH_CLEAR(r,c,s) 	(s**)memory_new_2dim_with_clear(r,c,sizeof(s))

typedef void (*func_memory_free)(void* data);

extern void* memory_new(int count, int size );
extern void* memory_new_with_clear(int count, int size);
extern void* memory_new_with_init(int count, int size, void* init);
extern void* memory_realloc_with_data(void** data, int old, int newsize, int size, func_memory_free func, int elementsize );
extern void* memory_realloc(void* data, int count, int size );
extern void  memory_free(void* data);
extern void** memory_new_2dim(int row, int col, int size );
extern void** memory_new_2dim_with_clear(int row, int col, int size );
extern void memory_free_2dim(void** data, int row, int col, func_memory_free func );
extern void** memory_copy_2dim(void** dst, void** src, int row, int col, int size );

#endif 
